%=============================================================
% Mecanismos
% Prof. Jorge Luiz Erthal
% Anlise geral e de ponto de interesse
% de um mecanismo biela-manivela
% Soluo da posio algbrica
%=============================================================
clear all
close all
clc
%-------------------------------------------------------------
%% dados numricos
%-------------------------------------------------------------
R=3;         % Comprimento da manivela (m)
C=0;          % Distancia do pistao ao centro da manivela (m)
L=10;         % comprimento da biela (m)
%-------------------------------------------------------------
% nmero de pontos
NP = 361;
qmin = 0*pi/180;
qmax = 360*pi/180;
%-------------------------------------------------------------
%% Anlises
%-------------------------------------------------------------
for i = 1:NP
    q(i)=qmin+(i-1)*(qmax-qmin)/(NP-1);
    %-------------------------------------------------------------
    %% anlise geral de posio
    %-------------------------------------------------------------
    a=asin((R*sin(q(i))-C)/L);
    x=R*cos(q(i))+L*cos(a);
    % distribuio do resultado nas variveis secundrias
    A(i)=a;     % armazenamento no vetor
    X(i)=x;     % armazenamento no vetor
end
%-------------------------------------------------------------
%% Grficos da anlise geral
%-------------------------------------------------------------
figure('Name','Anlise Geral')    % ttulo na moldura superior
% grficos geminados
% primeiro grfico
subplot(1,2,1)                    % grfico da esquerda (posio 1) 
plot(q*180/pi,A*180/pi,...                       
    'LineWidth',2)                % espessura da linha
grid on                           % linhas de grade
xlabel('q (^o)')                  % rtulo do eixo x
ylabel('A(q) (^o)')               % rtulo do eixo y
title('Posio da biela')         % ttulo do grfico
xlim([qmin*180/pi qmax*180/pi])
% segundo grfico
subplot(1,2,2)                    % grfico da direita (posio 2)
plot(q*180/pi,X,...
    'r',...                       % cor da curva
    'LineWidth',2)                % espessura da linha
grid on                           % insere linhas de grade
xlabel('q (^o)')                  % rtulo do eixo x
ylabel('X(q) (mm)')               % rtulo do eixo y
title('Posio do pisto')        % ttulo do grfico
xlim([qmin*180/pi qmax*180/pi])

%-------------------------------------------------------------
% FIM
%-------------------------------------------------------------
